/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.npc.GAddNpcToMiniMap
 *  fire.msp.npc.GRemoveNpcFromMiniMap
 *  fire.msp.npc.Pos
 *  fire.pb.GsClient
 *  fire.pb.util.MessageUtil
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.ActivityItemLimit
 *  xbean.ActivityStatus
 *  xbean.LimitItemInfo
 *  xbean.Pod
 *  xtable.Activitytable
 *  xtable.Awarditemlimit
 */
package fire.pb.timer;

import fire.msp.npc.GAddNpcToMiniMap;
import fire.msp.npc.GRemoveNpcFromMiniMap;
import fire.msp.npc.Pos;
import fire.pb.GsClient;
import fire.pb.timer.IScheduledActivity;
import fire.pb.timer.MiniMapNpc;
import fire.pb.util.MessageUtil;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ScheduledFuture;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.ActivityItemLimit;
import xbean.ActivityStatus;
import xbean.LimitItemInfo;
import xbean.Pod;
import xtable.Activitytable;
import xtable.Awarditemlimit;

public abstract class AbstractScheduledActivity
implements IScheduledActivity {
    private List<Long> futures = new ArrayList<Long>();
    private static Map<Integer, Set<MiniMapNpc>> showNpcMaps = new HashMap<Integer, Set<MiniMapNpc>>();
    protected final int id;
    protected final int baseid;
    protected long activityStartTime;
    protected long activityEndTime;
    protected ScheduledFuture<?> startActivityFuture;
    protected ScheduledFuture<?> endActivityFuture;
    protected ScheduledFuture<?> resumeActivityFuture;
    protected ScheduledFuture<?> tmpstartActivityFuture;
    protected ScheduledFuture<?> tmpendActivityFuture;

    public AbstractScheduledActivity(int baseid, int id, long startTime, long endTime) {
        this.id = id;
        this.baseid = baseid;
        this.activityStartTime = startTime;
        this.activityEndTime = endTime;
    }

    @Override
    public final boolean start() throws Exception {
        logger.info((Object)("try to start activity.activity id:" + this.id));
        new Procedure(){

            protected boolean process() throws Exception {
                ActivityStatus activityStatus;
                ActivityItemLimit itemLimit = Awarditemlimit.get((Integer)AbstractScheduledActivity.this.baseid);
                if (itemLimit != null) {
                    for (LimitItemInfo info : itemLimit.getLimititemmap().values()) {
                        info.setNum(0);
                    }
                }
                if ((activityStatus = Activitytable.get((Integer)AbstractScheduledActivity.this.id)) == null) {
                    activityStatus = Pod.newActivityStatus();
                    Activitytable.insert((Integer)AbstractScheduledActivity.this.id, (ActivityStatus)activityStatus);
                }
                activityStatus.setBaseid(AbstractScheduledActivity.this.baseid);
                activityStatus.setId(AbstractScheduledActivity.this.id);
                activityStatus.setLaststarttime(System.currentTimeMillis());
                if (activityStatus.getInistarttime() == 0L) {
                    activityStatus.setInistarttime(AbstractScheduledActivity.this.activityStartTime);
                }
                if (activityStatus.getIniendtime() == 0L) {
                    activityStatus.setIniendtime(AbstractScheduledActivity.this.activityEndTime);
                }
                return true;
            }
        }.submit().get();
        if (this.init()) {
            logger.info((Object)("activity started.activity id:" + this.id));
            return true;
        }
        return false;
    }

    protected abstract boolean init() throws Exception;

    @Override
    public final boolean stop(boolean cancelFuture) throws Exception {
        logger.info((Object)("try to stop activity.activity id:" + this.id));
        if (this.stopActivity()) {
            MessageUtil.cancelRepeatablemsg(this.futures);
            if (cancelFuture) {
                if (this.startActivityFuture != null) {
                    this.startActivityFuture.cancel(true);
                }
                if (this.endActivityFuture != null) {
                    this.endActivityFuture.cancel(true);
                }
                if (this.resumeActivityFuture != null) {
                    this.resumeActivityFuture.cancel(true);
                }
            }
            new Procedure(){

                protected boolean process() throws Exception {
                    ActivityStatus activityStatus = Activitytable.get((Integer)AbstractScheduledActivity.this.id);
                    if (activityStatus != null) {
                        activityStatus.setLastendtime(System.currentTimeMillis());
                        long period = activityStatus.getLastendtime() - activityStatus.getLaststarttime();
                        if (period > 0L) {
                            activityStatus.setCosttime(activityStatus.getCosttime() + period);
                        }
                    }
                    return true;
                }
            }.submit().get();
            logger.info((Object)("activity stopped.activity id:" + this.id));
            return true;
        }
        return false;
    }

    protected abstract boolean stopActivity();

    @Override
    public final boolean end(boolean cancelFuture) throws Exception {
        logger.info((Object)("try to end activity.activity id:" + this.id));
        new Procedure(){

            protected boolean process() throws Exception {
                ActivityStatus activityStatus = Activitytable.get((Integer)AbstractScheduledActivity.this.id);
                if (activityStatus != null) {
                    Activitytable.remove((Integer)AbstractScheduledActivity.this.id);
                }
                return true;
            }
        }.submit().get();
        MessageUtil.cancelRepeatablemsg(this.futures);
        if (cancelFuture) {
            if (this.startActivityFuture != null) {
                this.startActivityFuture.cancel(true);
            }
            if (this.endActivityFuture != null) {
                this.endActivityFuture.cancel(true);
            }
            if (this.resumeActivityFuture != null) {
                this.resumeActivityFuture.cancel(true);
            }
        }
        if (this.endActivity()) {
            logger.info((Object)("activity ended.activity id:" + this.id));
            return true;
        }
        return false;
    }

    protected abstract boolean endActivity();

    public void addScheduledTask(long taskKey) {
        this.futures.add(taskKey);
    }

    public static final synchronized boolean addNpcToMiniMap(Collection<MiniMapNpc> npcsets) {
        Map<Integer, Set<MiniMapNpc>> activityNpcs = AbstractScheduledActivity.sortNpcByMapid(npcsets);
        for (Map.Entry<Integer, Set<MiniMapNpc>> entry : activityNpcs.entrySet()) {
            int mapid = entry.getKey();
            Set<MiniMapNpc> npcs = showNpcMaps.get(mapid);
            if (npcs == null) {
                npcs = new HashSet<MiniMapNpc>();
                showNpcMaps.put(mapid, npcs);
            }
            npcs.addAll((Collection<MiniMapNpc>)entry.getValue());
            GAddNpcToMiniMap gAddNpcToMiniMap = new GAddNpcToMiniMap();
            for (MiniMapNpc npc : entry.getValue()) {
                gAddNpcToMiniMap.baseids.add(npc.getBaseid());
                gAddNpcToMiniMap.poses.add(new Pos(npc.getPosx(), npc.getPosy()));
            }
            gAddNpcToMiniMap.sceneid = mapid;
            gAddNpcToMiniMap.roleid = 0L;
            GsClient.sendToScene((Protocol)gAddNpcToMiniMap);
        }
        return true;
    }

    public static final synchronized boolean removeNpcFromMiniMap(Collection<MiniMapNpc> npcsets) {
        if (npcsets == null || npcsets.isEmpty()) {
            return false;
        }
        Map<Integer, Set<MiniMapNpc>> activityNpcs = AbstractScheduledActivity.sortNpcByMapid(npcsets);
        if (!activityNpcs.isEmpty()) {
            for (Map.Entry<Integer, Set<MiniMapNpc>> entry : activityNpcs.entrySet()) {
                int mapid = entry.getKey();
                Set<MiniMapNpc> npcs = showNpcMaps.get(mapid);
                if (npcs == null) continue;
                npcs.removeAll((Collection)entry.getValue());
                GRemoveNpcFromMiniMap gRemoveNpcFromMiniMap = new GRemoveNpcFromMiniMap();
                for (MiniMapNpc npc : entry.getValue()) {
                    gRemoveNpcFromMiniMap.baseids.add(npc.getBaseid());
                }
                gRemoveNpcFromMiniMap.sceneid = mapid;
                GsClient.sendToScene((Protocol)gRemoveNpcFromMiniMap);
            }
        }
        return true;
    }

    public static void sendActivityNpcToMiniMap(long sceneid, long roleid) {
        try {
            Set<MiniMapNpc> npcs = showNpcMaps.get((int)sceneid);
            if (npcs != null && npcs.size() > 0) {
                GAddNpcToMiniMap gAddNpcToMiniMap = new GAddNpcToMiniMap();
                for (MiniMapNpc npc : npcs) {
                    gAddNpcToMiniMap.baseids.add(npc.getBaseid());
                    gAddNpcToMiniMap.poses.add(new Pos(npc.getPosx(), npc.getPosy()));
                }
                gAddNpcToMiniMap.sceneid = (int)sceneid;
                gAddNpcToMiniMap.roleid = roleid;
                GsClient.sendToScene((Protocol)gAddNpcToMiniMap);
            }
        }
        catch (Exception e) {
            logger.info((Object)("send minimap npc failed.sceneid:" + sceneid + "roleid:" + roleid));
        }
    }

    static Map<Integer, Set<MiniMapNpc>> sortNpcByMapid(Collection<MiniMapNpc> npcsets) {
        HashMap<Integer, Set<MiniMapNpc>> activityNpcs = new HashMap<Integer, Set<MiniMapNpc>>();
        for (MiniMapNpc npc : npcsets) {
            if (npc == null) continue;
            int mapid = npc.getSceneid();
            HashSet<MiniMapNpc> npcs = (HashSet<MiniMapNpc>)activityNpcs.get(mapid);
            if (npcs == null) {
                npcs = new HashSet<MiniMapNpc>();
                activityNpcs.put(mapid, npcs);
            }
            npcs.add(npc);
        }
        return activityNpcs;
    }

    @Override
    public long resume(boolean gm, long lastStartTime, long lastEndTime, long costTime) throws Exception {
        new Procedure(){

            protected boolean process() throws Exception {
                ActivityStatus activityStatus = Activitytable.get((Integer)AbstractScheduledActivity.this.id);
                if (activityStatus != null) {
                    activityStatus.setLaststarttime(System.currentTimeMillis());
                }
                return true;
            }
        }.submit().get();
        return this.resumeActivity(gm, lastStartTime, lastEndTime, costTime);
    }

    protected long resumeActivity(boolean gm, long lastStartTime, long lastEndTime, long costTime) throws Exception {
        return 0L;
    }

    public void setStartActivityFuture(ScheduledFuture<?> startActivityFuture) {
        this.startActivityFuture = startActivityFuture;
    }

    public void setEndActivityFuture(ScheduledFuture<?> endActivityFuture) {
        this.endActivityFuture = endActivityFuture;
    }

    public void setResumeActivityFuture(ScheduledFuture<?> resumeActivityFuture) {
        this.resumeActivityFuture = resumeActivityFuture;
    }

    public void setActivityStartTime(long activityStartTime) {
        this.activityStartTime = activityStartTime;
    }

    public void setActivityEndTime(long activityEndTime) {
        this.activityEndTime = activityEndTime;
    }

    public void setTmpstartActivityFuture(ScheduledFuture<?> tmpstartActivityFuture) {
        this.tmpstartActivityFuture = tmpstartActivityFuture;
    }

    public void setTmpendActivityFuture(ScheduledFuture<?> tmpendActivityFuture) {
        this.tmpendActivityFuture = tmpendActivityFuture;
    }
}

